package cn.ibizlab.core.analysis.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.analysis.domain.DAReport;
import cn.ibizlab.core.analysis.filter.DAReportSearchContext;
import cn.ibizlab.core.analysis.service.IDAReportService;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;
import com.alibaba.fastjson.JSONObject;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.analysis.mapper.DAReportMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import org.springframework.util.StringUtils;

/**
 * 实体[报表] 服务对象接口实现
 */
@Slf4j
@Service("DAReportServiceImpl")
public class DAReportServiceImpl extends ServiceImpl<DAReportMapper, DAReport> implements IDAReportService {


    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(DAReport et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getReportId()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<DAReport> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(DAReport et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("reportid", et.getReportId()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getReportId()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<DAReport> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public DAReport get(String key) {
        DAReport et = getById(key);
        if (et == null) {
            throw new BadRequestAlertException("数据不存在", this.getClass().getSimpleName(), key);
        }
        else {
        }
        return et;
    }

    @Override
    public DAReport getDraft(DAReport et) {
        return et;
    }

    @Override
    @Transactional
    public DAReport build(DAReport et) {
        //自定义代码
        return et;
    }

    @Override
    @Transactional
    public boolean buildBatch(List<DAReport> etList) {
        for(DAReport et : etList) {
            build(et);
        }
        return true;
    }

    @Override
    public boolean checkKey(DAReport et) {
        return (!ObjectUtils.isEmpty(et.getReportId())) && (!Objects.isNull(this.getById(et.getReportId())));
    }
    @Override
    @Transactional
    public boolean save(DAReport et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(DAReport et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<DAReport> list) {
        List<DAReport> create = new ArrayList<>();
        List<DAReport> update = new ArrayList<>();
        for (DAReport et : list) {
            if (ObjectUtils.isEmpty(et.getReportId()) || ObjectUtils.isEmpty(getById(et.getReportId()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<DAReport> list) {
        List<DAReport> create = new ArrayList<>();
        List<DAReport> update = new ArrayList<>();
        for (DAReport et : list) {
            if (ObjectUtils.isEmpty(et.getReportId()) || ObjectUtils.isEmpty(getById(et.getReportId()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }



    /**
     * 查询集合 数据集
     */
    @Override
    public Page<DAReport> searchDefault(DAReportSearchContext context) {
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<DAReport> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            return new PageImpl<DAReport>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }





    public IDAReportService getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



